#include <DualVNH5019MotorShield.h>

#include "DualVNH5019MotorShield.h"

DualVNH5019MotorShield md;
int EncoderM1_Pin = 3;

int difference;
int CPR = 12;
double delT;
int LOOPTIME = 1000;
long t1 = 0;
long t2 = 0;
double speed_act1 = 0;     // speed (actual value)


volatile unsigned long ticksM1 = 0;
volatile unsigned long ticksM1_old = 0;


void stopIfFault()
{
  if (md.getM1Fault())
  {
    Serial.println("M1 fault");
    while(1);
  }
  if (md.getM2Fault())
  {
    Serial.println("M2 fault");
    while(1);
  }
}

void ISR_CountTicksM1() { //interrupt service routine to count the right encoder ticks
  ticksM1++;
}

void getMotorData1()  {                                                        // calculate speed, volts and Amps
  static long ticksM1_old = 0;                                                   // last count
  t2 = millis();
  delT = t2 - t1;
  difference = ticksM1 - ticksM1_old;
  speed_act1 = (difference*60L*1000)/(delT*CPR);
  Serial.print("RPM1: ");
  Serial.println(ticksM1);
  ticksM1 = 0;
}

void setup()
{
  Serial.begin(9600);
  delay(2000);
  Serial.println("Dual VNH5019 Motor Shield");
  
  md.init();
  pinMode(EncoderM1_Pin, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(EncoderM1_Pin), ISR_CountTicksM1, HIGH);
  
  digitalWrite(EncoderM1_Pin, HIGH);
  for (int i = 0; i <= 400; i++)
  {
    md.setM1Speed(i);
    stopIfFault();
    if (i%200 == 100)
    {
      Serial.print("M1 current: ");
      Serial.println(md.getM1CurrentMilliamps());
    }
    delay(2);
  }

}

void loop()
{   

  md.setM1Speed(400);
  delay(50);

  t2 = millis() ;
  if (t2 - t1 >= LOOPTIME) {
    getMotorData1();


    t1 = t2;
  }
}

  //difference = ticksM1 - ticksM1_old;
  //curr_millis = millis();
  //delT = curr_millis - last_millis;

  //Serial.print("ticks: "); Serial.print(ticksM1); Serial.print("   delT: "); Serial.println(delT);


  //last_millis = curr_millis; ticksM1_old = ticksM1;

  //speed_act = (difference*60L*1000)/(delT*CPR);
  //Serial.print("RPM: "); Serial.println(speed_act);
